% IMAGINGCLOSE
%
%
function imagingclose(idinit)

if nargin==1
  delete(findobj('Userdata',idinit))
else
  %   delete(gco);
  %   pause
  set(gcf,'ButtonDownFcn','closereq',...
	  'Name','Cliquez pour fermer',...
	  'Menubar','none');
  set(findobj(gcf,'Type','image'),'ButtonDownFcn','closereq');
  set(findobj(gcf,'Type','text'),'ButtonDownFcn','closereq');
  clf;
  pages=getappdata(gcf,'pages');
  id=getappdata(gcf,'id');
  for i=1:length(pages)
    p=pages(i);
   % On verifie qu'elle existe
   if ishandle(p);
      % D'abord on limine les figures d'dition associes
      try 
	editfig=getappdata(p,'lineeditfig');
	for j=1:length(editfig)
	  f=editfig(j);
          % On verifie que la figure d'edition existe ...
	  if ishandle(f)
	    try
      	       % ... et qu'elle se raporte bien  la diagraphie
	       idfig=getappdata(f,'caller');
	       if isequal(id,idfig)
                 % Si oui, on ferme
		 close(f);
	       end
	    catch
	    end
	  end
	end
      end
   end
  end
  % On ferme ensuite la figure de diagraphie
  for i=1:length(pages)
    p=pages(i);
    if ishandle(p) & (p~=gcf)
      idpage=getappdata(p,'id');
      if isequal(id,idpage)
	close(p);
      end
    end
  end
end