% selectrange
%
% Remarque sur la prsentation des callback. Les fonctions internes
%  ce fichiers ne sont pas reconnus par les lments  
% d'interface graphiques. Il a donc fallu les appeler de maniere
% recursive par l fonction qui les a crs. 
% PRrequis
% @ rangeselect.fig Figure d'interface 
% La gestion de la ligne glissante est largement inspire de
% /toolbox/mapdisp/vote92.m 
%

function V=selectrange(datas)
if ~ischar(datas)
   % corps principal de la fonction 
   datas=reshape(datas,prod(size(datas)),1);
   cmin=min(datas);
   cmax=max(datas);
   %rangeselect; Vieille version plus utilise
   open('selectrange.fig')
   set(findobj(gcf,'Tag','valdeb'),'Callback','selectrange(''vmin'')');
   set(findobj(gcf,'Tag','valfin'),'Callback','selectrange(''vmax'')');
   % Je ne sais pas pourquoi mais guide ne veut pas sauver les 2
   % callbacks prcdents. 
   set(findobj(gcf,'Tag','valmin'),'string',num2str(cmin));
   set(findobj(gcf,'Tag','valdeb'),'string',num2str(cmin));
   set(findobj(gcf,'Tag','valmax'),'string',num2str(cmax));
   set(findobj(gcf,'Tag','valfin'),'string',num2str(cmax));
   axes(findobj(gcf,'Type','axes'));
   hist(datas,50);
   hold on;
   ylim = get(gca,'Ylim');
   linehndl1 = plot(cmin*[1 1],ylim,':',...
		    'EraseMode','xor', ...
		    'ButtonDownFcn', 'selectrange(''selection'');',....
		    'Color',[1 0 0],...
		    'Tag','debline');
   linehndl2 = plot(cmax*[1 1],ylim,':',...
		    'EraseMode','xor', ...
		    'ButtonDownFcn', 'selectrange(''selection'');',...
		    'Color',[1 0 0],...
		    'Tag','finline');
   uiwait;
   deb=str2num(get(findobj(gcf,'Tag','valdeb'),'string'));
   fin=str2num(get(findobj(gcf,'Tag','valfin'),'string'));
   V=[deb fin];
   V=sort(V);
   close(gcf);
else 
  switch datas
      % callback appels par la fonction principale pour des
      % raisons de visibilit des sous-fonctions 
   case 'selection'
      hndl = get(gcf,'CurrentObject');
      set(hndl,'UserData',gca);
      set(hndl,'Visible','off','LineWidth', 5);
      set(hndl,'Visible','on');
      set(gcf,'WindowButtonUpFcn', 'selectrange(''haut'');', ...
	      'WindowButtonMotionFcn', 'selectrange(''deplace'');');
   case 'deplace'
      hndl = get(gcf,'CurrentObject');
      %  Get the current cursor point and axis limits
      lineaxis = get(hndl,'Parent');
      point = get(lineaxis,'CurrentPoint');
      xlim  = get(lineaxis,'Xlim');
      ylim  = get(lineaxis,'Ylim');
      %  Update the slider line display
      newpt= min(max(point(1,1),xlim(1)),xlim(2));
	   cmax=str2num(get(findobj(gcf,'Tag','valmax'),'string'));
      newpt= min(newpt,cmax); % On fait en sorte de ne pas dpasser le max
	   cmin=str2num(get(findobj(gcf,'Tag','valmin'),'string'));
      newpt=max(newpt, cmin); % On fait en sorte de ne pas dpasser le min
      set(hndl, 'Xdata', newpt*[1 1]);
      switch get(hndl,'Tag')
      case 'debline'
         set(findobj(gcf,'Tag','valdeb'),'String',num2str(ceil(newpt)));
      case 'finline'
         set(findobj(gcf,'Tag','valfin'),'String',num2str(floor(newpt)));
      end
   case 'haut'
      %  Change the line slider width and set the appropriate
      %  window properties.
      hndl = get(gcf,'CurrentObject');
      axishndl = get(hndl,'UserData');
      set(gcf, 'WindowButtonUpFcn','', 'WindowButtonMotionFcn','');
      set(hndl,'Visible','off');
      set(hndl, 'LineWidth', 1, ...
		'ButtonDownFcn', 'selectrange(''selection'');');
      set(hndl,'Visible','on');
   case 'vmin'
      cmin=str2num(get(findobj(gcbf,'Tag','valmin'),'string'));
      cmax=str2num(get(findobj(gcbf,'Tag','valmax'),'string'));
      val=ceil(str2num(get(gcbo,'String')));
      val=min(max(val, cmin),cmax);
      set(gcbo,'string',num2str(val));
      set(findobj(gcf,'Tag','debline'),'Xdata',val*[1 1]);
   case 'vmax'
      cmin=str2num(get(findobj(gcbf,'Tag','valmin'),'string'));
      cmax=str2num(get(findobj(gcbf,'Tag','valmax'),'string'));
      val=floor(str2num(get(gcbo,'String')));
      val=min(max(val, cmin),cmax);
      set(gcbo,'string',num2str(val));
      set(findobj(gcf,'Tag','finline'),'Xdata',val*[1 1]);
   end
end


